//=============================================================================
// LoveMeMutator.
//=============================================================================
class LoveMeMutator expands Mutator
	config(LoveMePupae);

var array<PlayerPawn> PendingPlayers;
struct CustomizePupae
{
	var() config string DesiredPlayerName,PupaeName;
	var() config Color PupaeColor;
	var() config bool bHasGodMode,bRegenerating;
	var() config int RegenerationValue;
	var() config byte PupaeType;
	var() config float RegenerationTime;
};
var() config array<CustomizePupae> PupaeInfo;

function PostBeginPlay()
{
	AddToPackagesMap();
}
function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	if( Other.bIsPawn && PlayerPawn(Other)!=None && Spectator(Other)==None )
	{
		PendingPlayers[Array_Size(PendingPlayers)] = PlayerPawn(Other);
		SetTimer(0.1,false);
	}
	return true;
}
function Timer()
{
	local int i,j;
	local byte x,t;
	local vector V;
	local AveragePupae L;
	local string S;
	local LoveMeHelper H;
	
	for( i=(Array_Size(PendingPlayers)-1); i>=0; --i )
		if( PendingPlayers[i]!=None && !PendingPlayers[i].bDeleteMe && PendingPlayers[i].Player!=None )
		{
			S = Caps(PendingPlayers[i].PlayerReplicationInfo.PlayerName);
			for( j=(Array_Size(PupaeInfo)-1); j>=0; --j )
			{
				if (InStr(S,Caps(PupaeInfo[j].DesiredPlayerName))>=0)
					break;
			}
			for( x=0; x<16; ++x )
			{
				V = PendingPlayers[i].Location;
				V.X += FRand() * 600.f - 300.f;
				V.Y += FRand() * 600.f - 300.f;
				V.Z += FRand() * 100.f - 50.f;

				if( j==-1 )
					t = 0;
				else t = PupaeInfo[j].PupaeType;
				switch( t )
				{
				case 0:
					L = Spawn(Class'AveragePupae',,,V);
					break;
				case 1:
					L = Spawn(Class'LoveMePupae',,,V);
					break;
				case 2:
					L = Spawn(Class'FroggyPupae',,,V);
					break;
				case 3:
					L = Spawn(Class'FlowerPupae',,,V);
					break;		
				case 4:
					L = Spawn(Class'CrossyPupae',,,V);
					break;
				case 5:
					L = Spawn(Class'DottyPupae',,,V);
					break;							
				default:
					L = Spawn(Class'AveragePupae',,,V);
					break;
				}
				if( L!=None )
				{
					L.MyLove = PendingPlayers[i];
					H = Spawn(Class'LoveMeHelper',Owner);
					H.L = L;
					L.HelperItem = H;
					H.GiveTo(PendingPlayers[i]);

					if ( j>=0 )
					{
						L.PupaeColor = PupaeInfo[j].PupaeColor;
						L.CustomName = PupaeInfo[j].PupaeName;
						L.bHasGodMode = PupaeInfo[j].bHasGodMode;
						L.PostNetBeginPlay();
						if ( PupaeInfo[j].bRegenerating )
						{
							L.RegenerationValue = PupaeInfo[j].RegenerationValue;
							L.SetTimer(PupaeInfo[j].RegenerationTime, true, 'Regenerate');
						}
						else L.SetTimer(0, false, 'Regenerate');
					}
					break;
				}
			}
		}
	Array_Size(PendingPlayers,0);
}

defaultproperties
{
				PupaeInfo(0)=(DesiredPlayerName="Player",PupaeName="PPupae",PupaeColor=(R=255),PupaeType=2)
}
